<template>
  <div class="container">
    <div class="section">
      <user-detail
        :loading="loading"
        :name.sync="name"
        @submit="submit"
        @cancel="$router.push({ name: 'user' })"
      />
    </div>
  </div>
</template>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';
  import { Repository } from '@/modals/user';

  @Component<UserCreatePage>({
    components: {
      UserDetail: () => import('@/components/user/UserDetail.vue'),
    },
  })
  export default class UserCreatePage extends Vue {
    name: string = '';
    loading: boolean = false;

    submit() {
      this.loading = true;
      return Repository.create({ name: this.name })
        .then(() => {
          this.$router.push({ name: 'user' });
        });
    }
  }
</script>
